#!/usr/bin/python
# -*- coding: utf-8 -*-

# ################################################################################  
# ## Redistributions of source code must retain the above copyright notice
# ## DATE: 2011-01-23  
# ## AUTHOR: SecPoint ApS  
# ## MAIL: info@secpoint.com  
# ## SITE: http://www.secpoint.com  
# ## Other scanners: http://www.secpoint.com/free-port-scan.html
# ## Other scanners: http://www.secpoint.com/free-vulnerability-scan.html
# ##
# ## LICENSE: BSD http://www.opensource.org/licenses/bsd-license.php
# ################################################################################  
# ## 0.1 initial release
# ## 0.2 added Overview section to output

import os
import sys

usernamePasswordParam =  "-N"

def getList(ip):
  #first we should get all disks list
  #and some Overview here
  overViewF = os.popen(r'/usr/bin/smbclient -L %s %s 2>/dev/null'%(ip,usernamePasswordParam))
  overViewS = overViewF.readlines()
  overViewS = [s.strip() for s in overViewS]
  overViewString = "\n".join(overViewS) 
  overViewF.close()


  f = os.popen(r'/usr/bin/smbclient -L %s %s 2>/dev/null| grep " Disk " | sed -e "s/ Disk .*//" | sed -e "s/^[ \t]*//"'%(ip,usernamePasswordParam))
  disks = f.readlines()
  disks = filter(None, disks)
  disks = [d.strip() for d in disks]
  f.close()

  #now we will make DIR for each share and save output 
  listings = {}
  for disk in disks:
      f = os.popen(r'/usr/bin/smbclient //%s/"%s" %s -c "dir;exit" 2>/dev/null'%(ip,disk,usernamePasswordParam))
      dirlist =  f.readlines()
      dirlist = [d.strip() for d in dirlist]
      listings[disk]=dirlist
      f.close()

  #now we will prepare pretty output 

  resStrings = []

  foundString = ""
  for d in listings.keys():
      foundString = foundString + "Found share: %s\n%s\n\n\n"%(d,"\n".join(listings[d]))

  
  if listings:
    return overViewString+'\n'+foundString
  else:
    return ""

if __name__ == "__main__":
    if not os.popen(r'/usr/bin/smbclient -V 2>/dev/null').read():
        print "Error: smbclient not found in the system! Please visit www.samba.org"
        sys.exit()    
    if len(sys.argv) != 2:
      print "run with parameters:  <IP>"
      sys.exit()
    ipToScan = sys.argv[1]
    res = getList(ipToScan)
    print res
    
